#include "partition.h"
#include<bits/stdc++.h>
using namespace std;

const int MAXN = 1e7 + 5;
bool chetnost[MAXN], first[MAXN];
vector<int> pos[MAXN];

bool is_pow2(int a)
{
    while(a % 2 == 0)
    {
        a /= 2;
    }
    if(a == 1)
    {
        return true;
    }
    else
    {
        return false;
    }
}

vector<int> solve(vector<int> A)
{
    bool Case = false;
    for(int i = 0; i < A.size(); i++)
    {
        if(!is_pow2(A[i]))
        {
            Case = true;
        }
    }
    if(Case)
    {
        for(int i = 0; i < MAXN; i++)
        {
            chetnost[i] = false;
        }
        vector<int> otg1, otg2;
        for(int i = 0; i < A.size(); i++)
        {
            if(!chetnost[A[i]])
            {
                otg1.push_back(i);
                chetnost[A[i]] = true;
            }
            else
            {
                otg2.push_back(i);
                chetnost[A[i]] = false;
            }
        }
        vector<int> otg;
        for(int i = 0; i < otg1.size(); i++)
        {
            otg.push_back(otg1[i]);
        }
        for(int i = 0; i < otg2.size(); i++)
        {
            otg.push_back(otg2[i]);
        }
        return otg;
    }
    for(int i = 0; i < A.size(); i++)
    {
        pos[A[i]].push_back(i);
    }
    sort(A.begin(), A.end());
    reverse(A.begin(), A.end());
    int s1 = 0, s2 = 0;
    for(int i = 0; i < A.size(); i++)
    {
        if(s1 <= s2)
        {
            s1 += A[i];
            first[pos[i][pos[i].size() - 1]] = true;
            pos[i].pop_back();
        }
        else
        {
            s2 += A[i];
        }
    }
    vector<int> otg;
    for(int i = 0; i < A.size(); i++)
    {
        if(first[i]) otg.push_back(i);
    }
    for(int i = 0; i < A.size(); i++)
    {
        if(!first[i]) otg.push_back(i);
    }
    return otg;
}
